Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 95221)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 95222)
@@ -893,4 +893,5 @@
 	src/settings/UISettingsSelector.h \
 	src/settings/UISettingsSerializer.h \
+	src/settings/editors/UIAccelerationFeaturesEditor.h \
 	src/settings/editors/UIAudioControllerEditor.h \
 	src/settings/editors/UIAudioFeaturesEditor.h \
@@ -1469,4 +1470,5 @@
 	src/settings/UISettingsSelector.cpp \
 	src/settings/UISettingsSerializer.cpp \
+	src/settings/editors/UIAccelerationFeaturesEditor.cpp \
 	src/settings/editors/UIAudioControllerEditor.cpp \
 	src/settings/editors/UIAudioFeaturesEditor.cpp \
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAccelerationFeaturesEditor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAccelerationFeaturesEditor.cpp	(revision 95222)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAccelerationFeaturesEditor.cpp	(revision 95222)
@@ -0,0 +1,181 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UIAccelerationFeaturesEditor class implementation.
+ */
+
+/*
+ * Copyright (C) 2006-2022 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+/* Qt includes: */
+#include <QCheckBox>
+#include <QGridLayout>
+#include <QLabel>
+#include <QVBoxLayout>
+
+/* GUI includes: */
+#include "UIAccelerationFeaturesEditor.h"
+
+
+UIAccelerationFeaturesEditor::UIAccelerationFeaturesEditor(QWidget *pParent /* = 0 */)
+    : QIWithRetranslateUI<QWidget>(pParent)
+    , m_fEnableVirtualization(false)
+    , m_fEnableNestedPaging(false)
+    , m_pLabel(0)
+    , m_pCheckBoxEnableVirtualization(0)
+    , m_pCheckBoxEnableNestedPaging(0)
+{
+    prepare();
+}
+
+void UIAccelerationFeaturesEditor::setEnableVirtualization(bool fOn)
+{
+    /* Update cached value and
+     * check-box if value has changed: */
+    if (m_fEnableVirtualization != fOn)
+    {
+        m_fEnableVirtualization = fOn;
+        if (m_pCheckBoxEnableVirtualization)
+            m_pCheckBoxEnableVirtualization->setCheckState(m_fEnableVirtualization ? Qt::Checked : Qt::Unchecked);
+    }
+}
+
+bool UIAccelerationFeaturesEditor::isEnabledVirtualization() const
+{
+    return   m_pCheckBoxEnableVirtualization
+           ? m_pCheckBoxEnableVirtualization->checkState() == Qt::Checked
+           : m_fEnableVirtualization;
+}
+
+void UIAccelerationFeaturesEditor::setEnableVirtualizationAvailable(bool fAvailable)
+{
+    m_pCheckBoxEnableVirtualization->setEnabled(fAvailable);
+}
+
+void UIAccelerationFeaturesEditor::setEnableNestedPaging(bool fOn)
+{
+    /* Update cached value and
+     * check-box if value has changed: */
+    if (m_fEnableNestedPaging != fOn)
+    {
+        m_fEnableNestedPaging = fOn;
+        if (m_pCheckBoxEnableNestedPaging)
+            m_pCheckBoxEnableNestedPaging->setCheckState(m_fEnableNestedPaging ? Qt::Checked : Qt::Unchecked);
+    }
+}
+
+bool UIAccelerationFeaturesEditor::isEnabledNestedPaging() const
+{
+    return   m_pCheckBoxEnableNestedPaging
+           ? m_pCheckBoxEnableNestedPaging->checkState() == Qt::Checked
+           : m_fEnableNestedPaging;
+}
+
+void UIAccelerationFeaturesEditor::setEnableNestedPagingAvailable(bool fAvailable)
+{
+    m_pCheckBoxEnableNestedPaging->setEnabled(fAvailable);
+}
+
+int UIAccelerationFeaturesEditor::minimumLabelHorizontalHint() const
+{
+    return m_pLabel ? m_pLabel->minimumSizeHint().width() : 0;
+}
+
+void UIAccelerationFeaturesEditor::setMinimumLayoutIndent(int iIndent)
+{
+    if (m_pLayout)
+        m_pLayout->setColumnMinimumWidth(0, iIndent);
+}
+
+void UIAccelerationFeaturesEditor::retranslateUi()
+{
+    if (m_pLabel)
+        m_pLabel->setText(tr("Hardware Virtualization:"));
+    if (m_pCheckBoxEnableVirtualization)
+    {
+        m_pCheckBoxEnableVirtualization->setText(tr("Enable &VT-x/AMD-V"));
+        m_pCheckBoxEnableVirtualization->setToolTip(tr("When checked, the virtual machine will try to make use of the host "
+                                                       "CPU's hardware virtualization extensions such as Intel VT-x and AMD-V."));
+    }
+    if (m_pCheckBoxEnableNestedPaging)
+    {
+        m_pCheckBoxEnableNestedPaging->setText(tr("Enable Nested Pa&ging"));
+        m_pCheckBoxEnableNestedPaging->setToolTip(tr("When checked, the virtual machine will try to make use of the nested "
+                                                     "paging extension of Intel VT-x and AMD-V."));
+    }
+}
+
+void UIAccelerationFeaturesEditor::prepare()
+{
+    /* Prepare main layout: */
+    m_pLayout = new QGridLayout(this);
+    if (m_pLayout)
+    {
+        m_pLayout->setContentsMargins(0, 0, 0, 0);
+        m_pLayout->setColumnStretch(1, 1);
+
+        /* Prepare label layout: */
+        QVBoxLayout *pLayoutLabel = new QVBoxLayout;
+        if (pLayoutLabel)
+        {
+            /* Prepare virtualization label: */
+            m_pLabel = new QLabel(this);
+            if (m_pLabel)
+            {
+                m_pLabel->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
+                pLayoutLabel->addWidget(m_pLabel);
+            }
+            /* Prepare placeholder: */
+            QWidget *pWidgetPlaceholder = new QWidget(this);
+            if (pWidgetPlaceholder)
+            {
+#ifndef VBOX_WITH_RAW_MODE
+                /* Hide placeholder when raw-mode is not supported: */
+                pWidgetPlaceholder->setVisible(false);
+#endif
+                pLayoutLabel->addWidget(pWidgetPlaceholder);
+            }
+
+            m_pLayout->addLayout(pLayoutLabel, 0, 0);
+        }
+
+        /* Prepare widget layout: */
+        QVBoxLayout *pLayoutWidget = new QVBoxLayout;
+        if (pLayoutWidget)
+        {
+            /* Prepare 'enable PAE' check-box: */
+            m_pCheckBoxEnableVirtualization = new QCheckBox(this);
+            if (m_pCheckBoxEnableVirtualization)
+            {
+#ifndef VBOX_WITH_RAW_MODE
+                /* Hide check-box when raw-mode is not supported: */
+                m_pCheckBoxEnableVirtualization->setVisible(false);
+#endif
+                connect(m_pCheckBoxEnableVirtualization, &QCheckBox::stateChanged,
+                        this, &UIAccelerationFeaturesEditor::sigChangedVirtualization);
+                pLayoutWidget->addWidget(m_pCheckBoxEnableVirtualization);
+            }
+            /* Prepare 'enable nested virtualization' check-box: */
+            m_pCheckBoxEnableNestedPaging = new QCheckBox(this);
+            if (m_pCheckBoxEnableNestedPaging)
+            {
+                connect(m_pCheckBoxEnableNestedPaging, &QCheckBox::stateChanged,
+                        this, &UIAccelerationFeaturesEditor::sigChangedNestedPaging);
+                pLayoutWidget->addWidget(m_pCheckBoxEnableNestedPaging);
+            }
+
+            m_pLayout->addLayout(pLayoutWidget, 0, 1);
+        }
+    }
+
+    /* Apply language settings: */
+    retranslateUi();
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAccelerationFeaturesEditor.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAccelerationFeaturesEditor.h	(revision 95222)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAccelerationFeaturesEditor.h	(revision 95222)
@@ -0,0 +1,99 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UIAccelerationFeaturesEditor class declaration.
+ */
+
+/*
+ * Copyright (C) 2006-2022 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#ifndef FEQT_INCLUDED_SRC_settings_editors_UIAccelerationFeaturesEditor_h
+#define FEQT_INCLUDED_SRC_settings_editors_UIAccelerationFeaturesEditor_h
+#ifndef RT_WITHOUT_PRAGMA_ONCE
+# pragma once
+#endif
+
+/* GUI includes: */
+#include "QIWithRetranslateUI.h"
+
+/* Forward declarations: */
+class QCheckBox;
+class QGridLayout;
+class QLabel;
+
+/** QWidget subclass used as acceleration features editor. */
+class SHARED_LIBRARY_STUFF UIAccelerationFeaturesEditor : public QIWithRetranslateUI<QWidget>
+{
+    Q_OBJECT;
+
+signals:
+
+    /** Notifies listeners about virtualization change. */
+    void sigChangedVirtualization();
+    /** Notifies listeners about nested paging change. */
+    void sigChangedNestedPaging();
+
+public:
+
+    /** Constructs editor passing @a pParent to the base-class. */
+    UIAccelerationFeaturesEditor(QWidget *pParent = 0);
+
+    /** Defines whether 'enable virtualization' feature in @a fOn. */
+    void setEnableVirtualization(bool fOn);
+    /** Returns 'enable virtualization' feature value. */
+    bool isEnabledVirtualization() const;
+    /** Defines whether 'enable virtualization' option @a fAvailable. */
+    void setEnableVirtualizationAvailable(bool fAvailable);
+
+    /** Defines whether 'enable nested paging' feature in @a fOn. */
+    void setEnableNestedPaging(bool fOn);
+    /** Returns 'enable nested paging' feature value. */
+    bool isEnabledNestedPaging() const;
+    /** Defines whether 'enable nested paging' option @a fAvailable. */
+    void setEnableNestedPagingAvailable(bool fAvailable);
+
+    /** Returns minimum layout hint. */
+    int minimumLabelHorizontalHint() const;
+    /** Defines minimum layout @a iIndent. */
+    void setMinimumLayoutIndent(int iIndent);
+
+protected:
+
+    /** Handles translation event. */
+    virtual void retranslateUi() RT_OVERRIDE;
+
+private:
+
+    /** Prepares all. */
+    void prepare();
+
+    /** @name Values
+     * @{ */
+        /** Holds the 'enable virtualization' feature value. */
+        bool  m_fEnableVirtualization;
+        /** Holds the 'enable nested paging' feature value. */
+        bool  m_fEnableNestedPaging;
+    /** @} */
+
+    /** @name Widgets
+     * @{ */
+        /** Holds the main layout instance. */
+        QGridLayout *m_pLayout;
+        /** Holds the label instance. */
+        QLabel      *m_pLabel;
+        /** Holds the 'enable virtualization' check-box instance. */
+        QCheckBox   *m_pCheckBoxEnableVirtualization;
+        /** Holds the 'enable nested paging' check-box instance. */
+        QCheckBox   *m_pCheckBoxEnableNestedPaging;
+    /** @} */
+};
+
+#endif /* !FEQT_INCLUDED_SRC_settings_editors_UIAccelerationFeaturesEditor_h */
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSystem.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSystem.cpp	(revision 95221)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSystem.cpp	(revision 95222)
@@ -17,16 +17,14 @@
 
 /* Qt includes: */
-#include <QCheckBox>
-#include <QComboBox>
-#include <QLabel>
 #include <QVBoxLayout>
 
 /* GUI includes: */
 #include "QITabWidget.h"
+#include "UIAccelerationFeaturesEditor.h"
 #include "UIBaseMemoryEditor.h"
 #include "UIBootOrderEditor.h"
 #include "UIChipsetEditor.h"
 #include "UICommon.h"
-#include "UIConverter.h"
+//#include "UIConverter.h"
 #include "UIErrorString.h"
 #include "UIExecutionCapEditor.h"
@@ -164,9 +162,6 @@
     , m_pTabAcceleration(0)
     , m_pEditorParavirtProvider(0)
-    , m_pLabelVirtualization(0)
-    , m_pCheckBoxVirtualization(0)
-    , m_pCheckBoxNestedPaging(0)
-{
-    /* Prepare: */
+    , m_pEditorAccelerationFeatures(0)
+{
     prepare();
 }
@@ -174,5 +169,4 @@
 UIMachineSettingsSystem::~UIMachineSettingsSystem()
 {
-    /* Cleanup: */
     cleanup();
 }
@@ -186,5 +180,5 @@
 bool UIMachineSettingsSystem::isHWVirtExEnabled() const
 {
-    return m_pCheckBoxVirtualization->isChecked();
+    return m_pEditorAccelerationFeatures->isEnabledVirtualization();
 }
 
@@ -197,5 +191,5 @@
 bool UIMachineSettingsSystem::isNestedPagingEnabled() const
 {
-    return m_pCheckBoxNestedPaging->isChecked();
+    return m_pEditorAccelerationFeatures->isEnabledNestedPaging();
 }
 
@@ -326,8 +320,9 @@
     if (m_pEditorParavirtProvider)
         m_pEditorParavirtProvider->setValue(oldSystemData.m_paravirtProvider);
-    if (m_pCheckBoxVirtualization)
-        m_pCheckBoxVirtualization->setChecked(oldSystemData.m_fEnabledHwVirtEx);
-    if (m_pCheckBoxNestedPaging)
-        m_pCheckBoxNestedPaging->setChecked(oldSystemData.m_fEnabledNestedPaging);
+    if (m_pEditorAccelerationFeatures)
+    {
+        m_pEditorAccelerationFeatures->setEnableVirtualization(oldSystemData.m_fEnabledHwVirtEx);
+        m_pEditorAccelerationFeatures->setEnableNestedPaging(oldSystemData.m_fEnabledNestedPaging);
+    }
 
     /* Polish page finally: */
@@ -396,6 +391,6 @@
      * Nested HW Virt Ex is requested. */
     newSystemData.m_fEnabledNestedPaging =    isNestedPagingEnabled()
-                                     || (   isNestedPagingSupported()
-                                         && isNestedHWVirtExEnabled());
+                                           || (   isNestedPagingSupported()
+                                               && isNestedHWVirtExEnabled());
 
     /* Cache new data: */
@@ -608,6 +603,5 @@
 
     /* Configure navigation for 'acceleration' tab: */
-    setTabOrder(m_pEditorParavirtProvider, m_pCheckBoxVirtualization);
-    setTabOrder(m_pCheckBoxVirtualization, m_pCheckBoxNestedPaging);
+    setTabOrder(m_pEditorParavirtProvider, m_pEditorAccelerationFeatures);
 }
 
@@ -621,11 +615,4 @@
     m_pTabWidget->setTabText(m_pTabWidget->indexOf(m_pTabMotherboard), tr("&Motherboard"));
     m_pTabWidget->setTabText(m_pTabWidget->indexOf(m_pTabProcessor), tr("&Processor"));
-    m_pLabelVirtualization->setText(tr("Hardware Virtualization:"));
-    m_pCheckBoxVirtualization->setToolTip(tr("When checked, the virtual machine will try to make use of the host CPU's hardware "
-                                             "virtualization extensions such as Intel VT-x and AMD-V."));
-    m_pCheckBoxVirtualization->setText(tr("Enable &VT-x/AMD-V"));
-    m_pCheckBoxNestedPaging->setToolTip(tr("When checked, the virtual machine will try to make use of the nested paging "
-                                           "extension of Intel VT-x and AMD-V."));
-    m_pCheckBoxNestedPaging->setText(tr("Enable Nested Pa&ging"));
     m_pTabWidget->setTabText(m_pTabWidget->indexOf(m_pTabAcceleration), tr("Acce&leration"));
 
@@ -649,4 +636,9 @@
     m_pEditorExecCap->setMinimumLayoutIndent(iMinimumLayoutHint);
     m_pEditorProcessorFeatures->setMinimumLayoutIndent(iMinimumLayoutHint);
+    iMinimumLayoutHint = 0;
+    iMinimumLayoutHint = qMax(iMinimumLayoutHint, m_pEditorParavirtProvider->minimumLabelHorizontalHint());
+    iMinimumLayoutHint = qMax(iMinimumLayoutHint, m_pEditorAccelerationFeatures->minimumLabelHorizontalHint());
+    m_pEditorParavirtProvider->setMinimumLayoutIndent(iMinimumLayoutHint);
+    m_pEditorAccelerationFeatures->setMinimumLayoutIndent(iMinimumLayoutHint);
 }
 
@@ -673,10 +665,10 @@
     /* Polish 'Acceleration' availability: */
     m_pEditorParavirtProvider->setEnabled(isMachineOffline());
-    m_pLabelVirtualization->setEnabled(isMachineOffline());
-    m_pCheckBoxVirtualization->setEnabled(   (systemData.m_fSupportedHwVirtEx && isMachineOffline())
-                                          || (systemData.m_fEnabledHwVirtEx && isMachineOffline()));
-    m_pCheckBoxNestedPaging->setEnabled(   m_pCheckBoxVirtualization->isChecked()
-                                        && (   (systemData.m_fSupportedNestedPaging && isMachineOffline())
-                                            || (systemData.m_fEnabledNestedPaging && isMachineOffline())));
+    m_pEditorAccelerationFeatures->setEnabled(isMachineOffline());
+    m_pEditorAccelerationFeatures->setEnableVirtualizationAvailable(   (systemData.m_fSupportedHwVirtEx && isMachineOffline())
+                                                                    || (systemData.m_fEnabledHwVirtEx && isMachineOffline()));
+    m_pEditorAccelerationFeatures->setEnableNestedPagingAvailable(   m_pEditorAccelerationFeatures->isEnabledVirtualization()
+                                                                  && (   (systemData.m_fSupportedNestedPaging && isMachineOffline())
+                                                                      || (systemData.m_fEnabledNestedPaging && isMachineOffline())));
 }
 
@@ -685,7 +677,7 @@
     /* Update Nested Paging checkbox: */
     AssertPtrReturnVoid(m_pCache);
-    m_pCheckBoxNestedPaging->setEnabled(   m_pCheckBoxVirtualization->isChecked()
-                                        && (   (m_pCache->base().m_fSupportedNestedPaging && isMachineOffline())
-                                            || (m_pCache->base().m_fEnabledNestedPaging && isMachineOffline())));
+    m_pEditorAccelerationFeatures->setEnableNestedPagingAvailable(   m_pEditorAccelerationFeatures->isEnabledVirtualization()
+                                                                  && (   (m_pCache->base().m_fSupportedNestedPaging && isMachineOffline())
+                                                                      || (m_pCache->base().m_fEnabledNestedPaging && isMachineOffline())));
 
     /* Revalidate: */
@@ -819,53 +811,10 @@
             m_pEditorParavirtProvider = new UIParavirtProviderEditor(m_pTabAcceleration);
             if (m_pEditorParavirtProvider)
-                pLayoutAcceleration->addWidget(m_pEditorParavirtProvider, 0, 0, 1, 3);
-
-            /* Prepare virtualization label layout: */
-            QVBoxLayout *pLayoutVirtualizationLabel = new QVBoxLayout;
-            if (pLayoutVirtualizationLabel)
-            {
-                /* Prepare virtualization label: */
-                m_pLabelVirtualization = new QLabel(m_pTabAcceleration);
-                if (m_pLabelVirtualization)
-                {
-                    m_pLabelVirtualization->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
-                    pLayoutVirtualizationLabel->addWidget(m_pLabelVirtualization);
-                }
-                /* Prepare placeholder: */
-                QWidget *pWidgetPlaceholder = new QWidget(m_pTabAcceleration);
-                if (pWidgetPlaceholder)
-                {
-#ifndef VBOX_WITH_RAW_MODE
-                    /* Hide placeholder when raw-mode is not supported: */
-                    pWidgetPlaceholder->setVisible(false);
-#endif
-
-                    pLayoutVirtualizationLabel->addWidget(pWidgetPlaceholder);
-                }
-
-                pLayoutAcceleration->addLayout(pLayoutVirtualizationLabel, 1, 0);
-            }
-            /* Prepare virtualization stuff layout: */
-            QVBoxLayout *pLayoutVirtualizationStuff = new QVBoxLayout;
-            if (pLayoutVirtualizationStuff)
-            {
-                /* Prepare virtualization check-box: */
-                m_pCheckBoxVirtualization = new QCheckBox(m_pTabAcceleration);
-                if (m_pCheckBoxVirtualization)
-                {
-#ifndef VBOX_WITH_RAW_MODE
-                    /* Hide HW Virt Ex checkbox when raw-mode is not supported: */
-                    m_pCheckBoxVirtualization->setVisible(false);
-#endif
-
-                    pLayoutVirtualizationStuff->addWidget(m_pCheckBoxVirtualization);
-                }
-                /* Prepare nested paging check-box: */
-                m_pCheckBoxNestedPaging = new QCheckBox(m_pTabAcceleration);
-                if (m_pCheckBoxNestedPaging)
-                    pLayoutVirtualizationStuff->addWidget(m_pCheckBoxNestedPaging);
-
-                pLayoutAcceleration->addLayout(pLayoutVirtualizationStuff, 1, 1);
-            }
+                pLayoutAcceleration->addWidget(m_pEditorParavirtProvider, 0, 0, 1, 2);
+
+            /* Prepare acceleration features editor: */
+            m_pEditorAccelerationFeatures = new UIAccelerationFeaturesEditor(m_pTabAcceleration);
+            if (m_pEditorAccelerationFeatures)
+                pLayoutAcceleration->addWidget(m_pEditorAccelerationFeatures, 1, 0);
 
             m_pTabWidget->addTab(m_pTabAcceleration, QString());
@@ -895,7 +844,7 @@
 
     /* Configure 'Acceleration' connections: */
-    connect(m_pCheckBoxVirtualization, &QCheckBox::stateChanged,
+    connect(m_pEditorAccelerationFeatures, &UIAccelerationFeaturesEditor::sigChangedVirtualization,
             this, &UIMachineSettingsSystem::sltHandleHwVirtExToggle);
-    connect(m_pCheckBoxNestedPaging, &QCheckBox::stateChanged,
+    connect(m_pEditorAccelerationFeatures, &UIAccelerationFeaturesEditor::sigChangedNestedPaging,
             this, &UIMachineSettingsSystem::revalidate);
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSystem.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSystem.h	(revision 95221)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSystem.h	(revision 95222)
@@ -28,8 +28,6 @@
 struct UIDataSettingsMachineSystem;
 typedef UISettingsCache<UIDataSettingsMachineSystem> UISettingsCacheMachineSystem;
-class QCheckBox;
-class QComboBox;
-class QLabel;
 class QITabWidget;
+class UIAccelerationFeaturesEditor;
 class UIBaseMemoryEditor;
 class UIBootOrderEditor;
@@ -174,13 +172,9 @@
 
         /** Holds the 'Acceleration' tab instance. */
-        QWidget                  *m_pTabAcceleration;
+        QWidget                      *m_pTabAcceleration;
         /** Holds the paravirtualization provider editor instance. */
-        UIParavirtProviderEditor *m_pEditorParavirtProvider;
-        /** Holds the virtualization label instance. */
-        QLabel                   *m_pLabelVirtualization;
-        /** Holds the virtualization check-box instance. */
-        QCheckBox                *m_pCheckBoxVirtualization;
-        /** Holds the nested paging check-box instance. */
-        QCheckBox                *m_pCheckBoxNestedPaging;
+        UIParavirtProviderEditor     *m_pEditorParavirtProvider;
+        /** Holds the acceleration features editor instance. */
+        UIAccelerationFeaturesEditor *m_pEditorAccelerationFeatures;
    /** @} */
 };